ST_TotalSteps=0;
ST_TPList= {};
ST_CurrentStep=0;
ST_Input="";
ST_T1 = 0;
ST_T2 = 0;
ST_T3 = 0;
ST_TotalTalents=0;
SetTalentsConfig = {};

StaticPopupDialogs["SETTALENTS_WARNING"] = {
  text = "You have talent preview turned on, the addon dont support preview and will set your talents directly if you go on!\r\n(you can turn off this warning in the options) ",
  button1 = "Continue",
  button2 = "Abort",
  OnAccept = function()
      SetTalents_Test();
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

function SetTalents_OnLoad()
	 SlashCmdList["SETTALENTS"] = SetTalents_SlashHandler;
	SLASH_SETTALENTS1 = "/settalents";
	SetTalentsFrame:RegisterEvent("ADDON_LOADED");

end

function SetTalents_SlashHandler(cmd)
	 local a,b,c=strfind(cmd, "(%S+)");
 	 if a then
 		ST_Input = strsub(cmd, a);
     end
	if((GetCVarBool("previewTalents")) and (SetTalents_Config.ShowWarning==1)) then
		StaticPopup_Show ("SETTALENTS_WARNING");
	else
		SetTalents_Test();
	end
end

function SetTalents_Test()
	--DEFAULT_CHAT_FRAME:AddMessage(ST_Input);
	--displayType = "crit";
	--local r = 0.1;
	--local g = 1.0;
	--local b = 0.1;
	--local stre = 1;
	--CombatText:AddMessage(ST_Input,scrollFunction,r,g,b,displayType,stre);
	
	local TPcount = 0;
	ST_TotalSteps = 0;
	ST_TPList = {}; 
	
	SetTalents_GetTalentsPerTab();
	for i = 1, strlen(ST_Input),1 do 
	  if(tonumber(strsub(ST_Input,i,i)) > 0) then
		for i2 = 1, tonumber(strsub(ST_Input,i,i)),1 do
			ST_TotalSteps = ST_TotalSteps + 1;
			tabnumber,talentnumber = SetTalents_GetTab(i);
			ST_TPList[ST_TotalSteps] = {};
			ST_TPList[ST_TotalSteps]["tab"] = tabnumber;	
			ST_TPList[ST_TotalSteps]["talent"] = talentnumber;	
		end
	   end
	end 
	if(ST_TotalSteps > UnitCharacterPoints("player")) then
		DEFAULT_CHAT_FRAME:AddMessage("You dont have enough Talentpoints...Script aborted");
		return;
	end
	if(ST_TotalTalents ~= strlen(ST_Input)) then
		DEFAULT_CHAT_FRAME:AddMessage("The argument is either too long or too short...Script aborted");
		return;
	end
	
	DEFAULT_CHAT_FRAME:AddMessage("Starting to set Talentpoints");
	ST_CurrentStep = 1;
	SetTalentsFrame:RegisterEvent("CHARACTER_POINTS_CHANGED");
	SetTalents_SetTalents();
	
end;

function SetTalents_GetTalentsPerTab()
	ST_T1 =  GetNumTalents(1);
	ST_T2 =  GetNumTalents(2)+ST_T1;
	ST_T3 =  GetNumTalents(3)+ST_T2;
	ST_TotalTalents = ST_T3;
	return;
end

function SetTalents_GetTab(TNumber)
	local rnumber = tonumber(TNumber);
	if (rnumber <= ST_T1) then
		return 1,rnumber;
	elseif(rnumber <= ST_T2) then
		rnumber = rnumber - ST_T1;
		return 2,rnumber;
	else
		rnumber = rnumber - ST_T2;
		return 3,rnumber;
	end
end


function SetTalents_SetTalents()
	if(ST_CurrentStep == ST_TotalSteps) then
		SetTalentsFrame:UnregisterEvent("CHARACTER_POINTS_CHANGED");
		DEFAULT_CHAT_FRAME:AddMessage("Setting Talentpoints finished");
	end
	LearnTalent(ST_TPList[ST_CurrentStep]["tab"],ST_TPList[ST_CurrentStep]["talent"]);
	ST_CurrentStep = ST_CurrentStep + 1;
end

function SetTalents_OnEvent()
	if(event == "CHARACTER_POINTS_CHANGED") then
		SetTalents_SetTalents();
	elseif(event == "ADDON_LOADED") then
		SetTalentsConfig:Init();
        SetTalentsFrame:UnregisterEvent("ADDON_LOADED");
	end
end

